#line 1 "C:/Users/Usuario/Documents/MikroC_pro_pic/74HC595/LCD_2x16_74HC595_8bit.c"
#line 1 "c:/users/usuario/documents/mikroc_pro_pic/74hc595/lcd_2x16_74hc595_8bit.h"





void shiftdata595(unsigned char _shiftdata);
void Latch(void);
void LCD_Init (void);
void LCD_Command(char data1);
void Lcd_Chr_CP(char data1);
void LCD_Char_xy (char row, char pos, char ch);
void LCD_String_xy (char row, char pos, char *str);
#line 8 "C:/Users/Usuario/Documents/MikroC_pro_pic/74HC595/LCD_2x16_74HC595_8bit.c"
char LCD_port=0;

void shiftdata595(unsigned char _shiftdata)
{
unsigned int i;
unsigned char temp;
temp = _shiftdata;
i=8;
while (i>0)
{
if ((temp&0x80)==0)
{
 RB0_bit  = 0;
}
else
{
 RB0_bit  = 1;
}
temp = temp<<1;
 RB1_bit  = 1;
Delay_us(1);
 RB1_bit  = 0;
i--;
}
}

void Latch(){

 RB2_bit  = 1;
Delay_us(2);
 RB2_bit  = 0;
Delay_us(2);

}
void LCD_Command(char data1)
{
 shiftdata595(data1);
 shiftdata595(0x10);
 Latch();
 delay_us(400);
 shiftdata595(data1);
 shiftdata595(0x00);
 Latch();
 delay_ms(2);
}
void Lcd_Chr_CP(char data1){

 shiftdata595(data1);
 shiftdata595(0x14);
 Latch();
 delay_us(400);
 shiftdata595(data1);
 shiftdata595(0x04);
 Latch();
 delay_ms(2);

}
void LCD_Char_xy (char row, char pos, char ch)
{
char i=0;

 switch(row){
 case 1:
 LCD_Command(0x80 + pos-1);
 break;
 case 2:
 LCD_Command(0xC0 + pos-1);
 break;
 case 3:
 LCD_Command(0x94 + pos-1);
 break;
 case 4:
 LCD_Command(0xD4 + pos-1);
 break;
 }
 Lcd_Chr_CP (ch);

}
void LCD_String_xy (char row, char pos, char *str)
{
char i=0;

 switch(row){
 case 1:
 LCD_Command(0x80 + pos-1);
 break;
 case 2:
 LCD_Command(0xC0 + pos-1);
 break;
 case 3:
 LCD_Command(0x94 + pos-1);
 break;
 case 4:
 LCD_Command(0xD4 + pos-1);
 break;
 }


 for(i=0;str[i]!=0;i++)
 {
 Lcd_Chr_CP (str[i]);
 }
}

 void LCD_Init (void)
{
 delay_ms(15);
 LCD_Command (0x38);
 LCD_Command (0x0C);
 LCD_Command (0x06);
 LCD_Command (0x01);
 LCD_Command (0x80);

}
